export type tAccordionMode = 'flush' | 'alwaysOpen' | 'default';

export type tAccordionPanel = {
    isOpen: boolean;
};

type tAccordionPanels = {
    [key: string]: tAccordionPanel;
};

type tStateElement = {
    id: string;
    flush: boolean;
    alwaysOpen: boolean;
    openFirstItem: boolean;
    panels: tAccordionPanels;
};

export type tState = {
    [key: string]: tStateElement;
};
//////////////

export interface AccordionHeaderProps {
    ripple?: boolean;
}

export interface AccordionProps {
    openFirstItem?: boolean;
    alwaysOpen?: boolean;
    mode?: 'single' | 'multi';
    class?: string | string[];
}

export type tAccordionStates = {
    options: AccordionProps;
    initialized: boolean;
    panels: { [key: number]: tAccordionPanel };
};

export type AccordionPanelProps = {};
