import resolveConfig from 'tailwindcss/resolveConfig';
import tailwindConfig from '../tailwind.config';
import type { DefaultTheme } from 'tailwindcss/types/generated/default-theme';
import type { DefaultColors } from 'tailwindcss/types/generated/colors';
import type { Config, ResolvableTo, ThemeConfig } from 'tailwindcss/types/config';
export const useTailwindConf = (): ResolvedConfig<Config> => resolveConfig(tailwindConfig);

export type ResolvedConfig<T extends Config> = Omit<T, 'theme'> & {
    theme: MergeThemes<UnwrapResolvables<Omit<T['theme'], 'extend'>>, T['theme'] extends { extend: infer TExtend } ? UnwrapResolvables<TExtend> : {}>;
};

type MergeThemes<Overrides extends object, Extensions extends object> = {
    [K in keyof ThemeConfigResolved | keyof Overrides]: (K extends keyof Overrides
        ? Overrides[K]
        : K extends keyof DefaultThemeFull
          ? DefaultThemeFull[K]
          : K extends keyof ThemeConfigResolved
            ? ThemeConfigResolved[K]
            : never) &
        (K extends keyof Extensions ? Extensions[K] : {});
};

type UnwrapResolvables<T> = {
    [K in keyof T]: T[K] extends ResolvableTo<infer R> ? R : T[K];
};

type ThemeConfigResolved = UnwrapResolvables<ThemeConfig>;
type DefaultThemeFull = DefaultTheme & { colors: DefaultColors };
